import * as React from 'react';
import { Params, DropFirst } from 'src/helperTypes';
declare type Action<TState, TArgs extends any[] = any, TReturn = void> = (setState: React.Dispatch<React.SetStateAction<TState>>, ...args: TArgs) => TReturn;
declare type Actions<TState> = {
    [key: string]: Action<TState>;
};
declare type MappedActions<TState, TActions extends Actions<TState>> = {
    [P in keyof TActions]: (...args: DropFirst<Params<TActions[P]>>) => ReturnType<TActions[P]>;
};
declare type Store<TState, TActions extends Actions<TState>> = TActions extends undefined ? TState : TState & MappedActions<TState, TActions>;
export default function createStateContext<TState, TActions extends Actions<TState> = {}>(initialState: TState, actions?: TActions): [React.Context<Store<TState, TActions>>, React.FC];
export {};
