"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
function createStateContext(initialState, actions) {
    var store = __assign({}, initialState, mapActionsToDefault(actions));
    var context = React.createContext(store);
    var provider = function (props) {
        var _a = React.useState(initialState), _state = _a[0], setState = _a[1];
        var _actions = mapActionsToDispatch(setState, actions);
        var _store = __assign({}, _state, _actions);
        return (React.createElement(context.Provider, { value: _store }, props.children));
    };
    return [context, provider];
}
exports.default = createStateContext;
function mapActionsToDispatch(dispatch, actions) {
    if (actions === undefined)
        return {};
    return Object.keys(actions).reduce(function (obj, key) {
        var _a;
        return __assign({}, obj, (_a = {}, _a[key] = function () {
            var payload = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                payload[_i] = arguments[_i];
            }
            return actions[key](dispatch, payload[0]);
        }, _a));
    }, {});
}
function mapActionsToDefault(actions) {
    if (actions === undefined)
        return {};
    return Object.keys(actions).reduce(function (obj, key) {
        var _a;
        return __assign({}, obj, (_a = {}, _a[key] = function () {
            var payload = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                payload[_i] = arguments[_i];
            }
            return function () { throw new Error("Can't invoke " + key + " because provider does not exist"); };
        }, _a));
    }, {});
}
